#include "ptr.h"

int dfgmx, dfgmy;
unsigned int dfwdx, dfwdy;
double dfx, dfy;
double dfwid, dfhgt;

PGColor fgcolor;
PGColor bgcolor;

double stlnum=STLNUM;
double stllength=STLLENGTH;


void SetDefaultGeometry(int gmx, int gmy){
    dfgmx=gmx;  dfgmy=gmy;
}
int DefaultGMX(){
    return dfgmx;
}
int DefaultGMY(){
    return dfgmy;
}
void SetDefaultFrameSize(unsigned int wdx, unsigned int wdy){
    dfwdx=wdx;  dfwdy=wdy;
}
unsigned int DefaultWDX(){
    return dfwdx;
}
unsigned int DefaultWDY(){
    return dfwdy;
}

void SetDefaultWindowXY(double x, double y){
    dfx=x;  dfy=y;
}
double DefaultWindowX(){
    return dfx;
}
double DefaultWindowY(){
    return dfy;
}
void SetDefaultWindowSize(double wid, double hgt){
    dfwid=wid;  dfhgt=hgt;
}
double DefaultWindowW(){
    return dfwid;
}
double DefaultWindowH(){
    return dfhgt;
}


int SetColor(int r, int g, int b)
{
    PGColor pgcl;
    EnterFunc("SetColor");
    if(PGGetColor(r, g, b, &pgcl)){
        SetDefaultColor(pgcl);
        LeaveFunc();  return TRUE;
    }else{
        SetError(ERROR, "Can't allocate color.\n");
        LeaveFunc();  return FALSE;
    }
    LeaveFunc();
}
int SetNamedColor(char* name)
{
    PGColor pgcl;
    EnterFunc("SetNamedColor");
    if(PGGetNamedColor(name, &pgcl)){
        SetDefaultColor(pgcl);
        LeaveFunc();  return TRUE;
    }else{
        char msg[MAX_STR];
        sprintf(msg, "Can't allocate color: \"%s\"\n", name);
        SetError(ERROR, msg);
        LeaveFunc();  return FALSE;
    }
    LeaveFunc();
}
int GetNamedColor(char* name, PGColor* pgcl)
{
    int ret;
    ret=PGGetNamedColor(name, pgcl);
    return ret;
}
int GetColor(int r, int g, int b, PGColor* pgcl)
{
    int ret;
    ret=PGGetColor(r, g, b, pgcl);
    return ret;
}
int SetDefaultColors(char* fgname, char* bgname){
    return (GetNamedColor(fgname, &fgcolor)
            && GetNamedColor(bgname, &bgcolor));
}
PGColor DefaultForeground(){
    return fgcolor;
}
PGColor DefaultBackground(){
    return bgcolor;
}

void SetStreamLineNum(int num){
    stlnum=num;
}
int StreamLineNum(){
    return stlnum;
}
void SetStreamLineLength(double length){
    stllength=length;
}
double StreamLineLength(){
    return stllength;
}
